=== tests/bitmaps/Makefile ===
# Copyright (c) 2011 The Chromium OS Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

export BMPBLK=${BUILD}/utility/bmpblk_utility

runtests:
	./TestBmpBlock.py -v
