=== debian/changelog ===
vboot-utils (0~20121212-3) unstable; urgency=low

  * Added patch to make use that CPPFLAGS and LDFLAGS are used.

 -- Marcin Juszkiewicz <marcin@juszkiewicz.com.pl>  Tue, 04 Jun 2013 22:26:58 +0200

vboot-utils (0~20121212-2) unstable; urgency=low

  * bumped debhelper to v9 to get hardening support
  * fixed lintian warnings
    * updated manpages
    * fixed copyright Files: entries
    * updated Standards-Version to 3.9.4 (no changes)
    * enlarged vboot-kernel-utils description a bit
    * fixed Vcs links
  * Merged few changes from Shawn Landden repo:
    * Tests are now run after build.
    * Added manpages for cgpt, crossystem vbutil_kernel.
    * Added openssl, python, realpath to build dependencies - tests
      requirements.

 -- Marcin Juszkiewicz <marcin@juszkiewicz.com.pl>  Tue, 12 Mar 2013 22:07:17 +0800

vboot-utils (0~20121212-1) unstable; urgency=low

  [ Antonio Terceiro ]
  * Initial release.
  * Added patches to:
    - build utilities as shared binaries
    - Fix build on armhf by removing -Werror from build flags

  [ Marcin Juszkiewicz ]
  * Added patch to build cgpt as shared binary.

 -- Antonio Terceiro <terceiro@debian.org>  Sun, 16 Dec 2012 11:03:40 -0300
