=== debian/control ===
Source: vboot-utils
Section: admin
Priority: extra
Maintainer: Antonio Terceiro <terceiro@debian.org>
Build-Depends: debhelper (>= 9.0.0), libtspi-dev, liblzma-dev, uuid-dev,
  libssl-dev, pkg-config, libyaml-dev, openssl, realpath, python
Standards-Version: 3.9.4
Vcs-Git: git://anonscm.debian.org/collab-maint/vboot-utils.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/vboot-utils.git;a=summary
Homepage: http://git.chromium.org/gitweb/?p=chromiumos/platform/vboot_reference.git;a=summary

Package: vboot-utils
Architecture: armel armhf i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Chrome OS verified boot utils
 This package contains a set of tools to deal with Chromebook internals. Most
 users don't need this package, and should look for the cgpt and
 vboot-kernel-utils packages instead.

Package: cgpt
Architecture: armel armhf i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GPT manipulation tool with support for Chromium OS extensions
 Cgpt is a tool to manipulate GUID Partition Table from command line. It also
 supports Chromium OS extensions which allow to change priority for kernel
 partitions.

Package: vboot-kernel-utils
Architecture: armel armhf i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Chrome OS verified boot utils required to sign kernels
 This package provides the vbutil_kernel program required to sign custom
 kernels in order to get them booted by Chrome OS devices (i.e. Chromebooks).
 Developer keys are also provided.
