=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

VBOOT_UTILS_EXCLUDE = \
	-not -name vbutil_kernel

override_dh_auto_install:
	dh_install -pvboot-utils $$(find build/utility -type f -executable -and $(VBOOT_UTILS_EXCLUDE)) usr/bin

override_dh_auto_test:
	make runtests
