## vboot-utils 0~R52-8350.B

=== debian/changelog ===
vboot-utils (0~R52-8350.B-2) unstable; urgency=medium

  * Add missing build-depends: libssl1.0-dev. Keep using libssl 1.0 as
    upstream didn't update code for libssl 1.1 and changes are involved
    (Closes: #835801)
  * Drop useless build-depends: libtspi-dev

 -- Sophie Brun <sophie@freexian.com>  Fri, 02 Sep 2016 15:09:03 +0200

vboot-utils (0~R52-8350.B-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Import new upstream release (Closes: #828592)
  * Taking over with Antonio's permission (Closes: #798556)
  * Update patches: 0001-use-zu-as-appropriate-for-size_t.patch,
    0002-reduce-uname-down.patch, 0003-do-not-do-static-linking.patch,
    0004-skip-test-workbuf.patch, 0005-remove-Werror.patch,
    0006-add-CPPFLAGS-LDFLAGS.patch
  * Update the installation: futility program is now in vboot-kernel-utils
  * Update the manual pages (Closes: #735296)
  * Add patches to fix installation: 0007-fix-install-vboot_reference.patch,
    0010-change-install-directory-scripts.patch
  * Add a patch to try to fix build on arm64
  * Add a patch to drop a failing test
  * Add debian/watch

  [ Raphaël Hertzog ]
  * Don't override dh_builddeb to force xz compression, it's the default
    nowadays.
  * Drop vboot_host.pc as we don't install the associated static library.
  * Use https URL in Vcs-Browser.
  * Drop build dependency on dpkg-dev as versioned dependency is satisfied in
    oldstable (wheezy) and all newer releases.

 -- Sophie Brun <sophie@freexian.com>  Mon, 23 May 2016 10:55:20 +0200
