=== debian/control ===
Source: vboot-utils
Section: admin
Priority: extra
Maintainer: Sophie Brun <sophie@freexian.com> 
Uploaders: Raphael Hertzog <hertzog@debian.org>
Build-Depends: debhelper (>= 9),
               pkg-config,
               libyaml-dev,
               liblzma-dev,
               uuid-dev,
               libssl1.0-dev,
# tests/bitmaps/TestBmpBlock.py - needs python2 specifically?
               python,
# tests/external_rsa_signer.sh
               openssl
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/collab-maint/vboot-utils.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/vboot-utils.git
Homepage: http://git.chromium.org/gitweb/?p=chromiumos/platform/vboot_reference.git;a=summary

Package: vboot-utils
Architecture: armel armhf arm64 i386 amd64
Multi-Arch: foreign
# depend on vboot-kernel-utils for developer keys and for futility program
Depends: ${shlibs:Depends}, ${misc:Depends}, vboot-kernel-utils
Recommends: cgpt
Pre-Depends: ${misc:Pre-Depends}
Description: Chrome OS verified u-boot utilities
 This package contains a set of tools to deal with Chromebook internals,
 and the verified version of u-boot. Namely:
 bmpblk_font bmpblk_utility chromeos-tpm-recovery crossystem dev_debug_vboot
 dev_make_keypair dumpRSAPublicKey eficompress efidecompress enable_dev_usb_boot
 load_kernel_test pad_digest_utility signature_digest_utility tpm-nvsize
 tpm_init_temp_fix tpmc vbutil_what_key verify_data.
 .
 The programs previously included in this package: dump_fmap dump_kernel_config
 futility gbb_utility  vbutil_firmware vbutil_key vbutil_keyblock, are now
 grouped in the futility program in the package vboot-kernel-utils.
 .
 Most users don't need this package, and should look for the cgpt and
 vboot-kernel-utils packages instead.

Package: cgpt
Provides: crossystem
Architecture: armel armhf arm64 i386 amd64
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: GPT manipulation tool with support for Chromium OS extensions
 Cgpt is a tool to manipulate GUID Partition Table from command line. It also
 supports Chromium OS extensions enabling you to change priority for kernel
 partitions.

Package: vboot-kernel-utils
Architecture: armel armhf arm64 i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Chrome OS verified boot utils required to sign kernels
 This package provides the futility program (including the vbutil_kernel
 program required to sign custom kernels in order to get them booted by Chrome
 OS devices (i.e. Chromebooks)).
