=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_install:
	$(MAKE) DESTDIR=$$(pwd)/debian/vboot-utils/usr install
	mkdir -p $$(pwd)/debian/cgpt/usr/bin
	mv -t $$(pwd)/debian/cgpt/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/cgpt
	mkdir -p $$(pwd)/debian/vboot-kernel-utils/usr/bin
	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/vbutil_kernel
	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/futility
	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/futility_s
	# vboot_host.pc is useless without the static library (which
	# we could install with "make install-dev" but we currently don't)
	rm -f debian/vboot-utils/usr/lib/pkgconfig/vboot_host.pc
	rmdir --ignore-fail-on-non-empty -p debian/vboot-utils/usr/lib/pkgconfig

override_dh_auto_test:
	make runtests

%:
	dh $@ --parallel
