=== debian/watch ===
version=3
opts="downloadurlmangle=s|/\+/release-(.*)|/+archive/release-$1.tar.gz|g,uversionmangle=s|^|0~|" \
https://chromium.googlesource.com/chromiumos/platform/vboot_reference/+refs \
 /chromiumos/platform/vboot_reference/\+/release-(.*)
